package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class ClassGlob extends Glob {
  protected ClassNameGlob name;
  public ClassNameGlob get_name() { return name; }
  public void set_name(ClassNameGlob new_name) { name = new_name; }
  public ClassGlob() { super(); }
  public ClassGlob(ClassNameGlob name) {
    super();
    set_name(name);
  }
  public static ClassGlob parse(java.io.Reader in) throws ParseException { return new Parser(in)._ClassGlob(); }
  public static ClassGlob parse(java.io.InputStream in) throws ParseException { return new Parser(in)._ClassGlob(); }
  public static ClassGlob parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  public String toString() { return name.toString(); }
  public boolean equals(Object obj) {
    return toString().equals(obj.toString());
  }
  public int hashCode() {
    return toString().hashCode();
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_name(this, name);
    name.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_name(this, name);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

  void allGlobs_GlobSpec_trv_bef(GlobVisitor v) {
    super.allGlobs_GlobSpec_trv_bef(v);
    ((GlobVisitor) v).before(this);
  }

  void allGlobs_GlobSpec_trv_aft(GlobVisitor v) {
    ((UniversalVisitor) v).after(this);
    super.allGlobs_GlobSpec_trv_aft(v);
  }

  void allGlobs_GlobSpec_trv(GlobVisitor v) {
    allGlobs_GlobSpec_trv_bef(v);
    allGlobs_GlobSpec_trv_aft(v);
  }

  void __trav_matchEdge_GlobSpec_trv(__V_GlobSpec_matchEdge __v0) {  }

  void __trav_match_GlobSpec_trv_bef(__V_GlobSpec_match __v0) {
    super.__trav_match_GlobSpec_trv_bef(__v0);
  }

  void __trav_match_GlobSpec_trv_aft(__V_GlobSpec_match __v0) {
    super.__trav_match_GlobSpec_trv_aft(__v0);
  }

  void __trav_match_GlobSpec_trv(java.util.BitSet nodes, __V_GlobSpec_match __v0) {
    if (nodes.get(0)) nodes.set(1);
    __trav_match_GlobSpec_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(1);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        name.__trav_match_GlobSpec_trv(newnodes, __v0);
      }
    }
    __trav_match_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectClassGlobs_GlobSpec_trv_bef(__V_GlobSpec_collectClassGlobs __v0) {
    super.__trav_collectClassGlobs_GlobSpec_trv_bef(__v0);
    ((__V_GlobSpec_collectClassGlobs) __v0).before(this);
  }

  void __trav_collectClassGlobs_GlobSpec_trv_aft(__V_GlobSpec_collectClassGlobs __v0) {
    super.__trav_collectClassGlobs_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectClassGlobs_GlobSpec_trv(__V_GlobSpec_collectClassGlobs __v0) {
    __trav_collectClassGlobs_GlobSpec_trv_bef(__v0);
    __trav_collectClassGlobs_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectEdgeGlobs_GlobSpec_trv(__V_GlobSpec_collectEdgeGlobs __v0) {  }

  void allGlobs_ClassGlobSpec_trv_bef(GlobVisitor v) {
    super.allGlobs_ClassGlobSpec_trv_bef(v);
    ((GlobVisitor) v).before(this);
  }

  void allGlobs_ClassGlobSpec_trv_aft(GlobVisitor v) {
    ((UniversalVisitor) v).after(this);
    super.allGlobs_ClassGlobSpec_trv_aft(v);
  }

  void allGlobs_ClassGlobSpec_trv(GlobVisitor v) {
    allGlobs_ClassGlobSpec_trv_bef(v);
    allGlobs_ClassGlobSpec_trv_aft(v);
  }

  void __trav_match_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_match __v0) {
    super.__trav_match_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_match_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_match __v0) {
    super.__trav_match_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_match_ClassGlobSpec_trv(java.util.BitSet nodes, __V_ClassGlobSpec_match __v0) {
    if (nodes.get(0)) nodes.set(1);
    __trav_match_ClassGlobSpec_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(1);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        name.__trav_match_ClassGlobSpec_trv(newnodes, __v0);
      }
    }
    __trav_match_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_map_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_map __v0) {
    super.__trav_map_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_map_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_map __v0) {
    super.__trav_map_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_map_ClassGlobSpec_trv(__V_ClassGlobSpec_map __v0) {
    __trav_map_ClassGlobSpec_trv_bef(__v0);
    name.__trav_map_ClassGlobSpec_trv(__v0);
    __trav_map_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_addStrings __v0) {
    super.__trav_addStrings_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_addStrings __v0) {
    super.__trav_addStrings_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv(__V_ClassGlobSpec_addStrings __v0) {
    __trav_addStrings_ClassGlobSpec_trv_bef(__v0);
    name.__trav_addStrings_ClassGlobSpec_trv(__v0);
    __trav_addStrings_ClassGlobSpec_trv_aft(__v0);
  }

}
